SystemOrganization addCategory: #'GBT-DSL_LittleCompany'!

Object subclass: #HelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!HelloWorld class methodsFor: 'example' stamp: 'hk 6/6/2017 19:49'!
example
	GbtBizAppServer clearStore; clear. 
	(GbtThingEditor on: self hello) openWithSpec! !

!HelloWorld class methodsFor: 'things' stamp: 'hk 5/2/2017 16:47'!
hello
	^GbtSmartThing struct: 'hello' define: {
		{ #summary . 'Hello #yourName'}	.
		{ #yourName . #val: . ''}	}! !

Object subclass: #Invoices
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Invoices class methodsFor: 'example' stamp: 'hk 6/6/2017 19:50'!
exampleRun
	GbtBizAppServer clearStore; clear. 
	(self invoicesContext) ui title: #Invoices; open! !

!Invoices class methodsFor: 'things' stamp: 'hk 5/2/2017 16:47'!
invoice
	^GbtSmartThing struct: 'Invoice' define: {
		{ #date . #date: . Date today}.
		{ #Sum . #calc: . 'sum #tprice'}.
		{ #VAT . #calc: .  '0.19 * #Sum'}.
		{ #totals . #calc: .  '#VAT + #Sum'}.
		{ #items . #listOf: . LittleCompany product}.					
	} full: { 
		{ #customer . #thing: . Rolodex contact}.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 3/22/2017 13:22'!
invoiceContext 
	^GbtPlainAC struct: 'Invoice' define: {
		{#displayAs: . 'Invoice'  } .
		{#uiSpec:icon: . #GbtItemUI . #invoices}.
	"integration with other contexts in these 2 lines:"
		{#chooseFor:from: . #customer . Rolodex rolodex }.
		{#chooseFor:from: . #items . LittleCompany productsContext }.
	}! !

!Invoices class methodsFor: 'context' stamp: 'hk 6/7/2017 10:49'!
invoicesContext  
	^GbtPrimeListAC struct: 'Invoices' define: {
		{#displayAs: . 'Invoices'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #invoicing} .
		{#templates: . self invoice} .
		{#display: . #(firstName lastName company date Sum VAT totals)} .
		{#subcontext: . self invoiceContext} }! !

Object subclass: #LittleCompany
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!LittleCompany class methodsFor: 'example' stamp: 'hk 6/6/2017 19:54'!
ensureCompilation
	GbtBizAppServer default hasContexts ifFalse: 
		[self login]! !

!LittleCompany class methodsFor: 'example' stamp: 'hk 6/6/2017 19:53'!
exampleRun
	(self 
		ensureCompilation;
		installUsers;
		login) open! !

!LittleCompany class methodsFor: 'example' stamp: 'hk 5/5/2017 19:22'!
example_CleanUp
	GbtBizAppServer clearStore; clear. 
! !

!LittleCompany class methodsFor: 'example' stamp: 'hk 3/28/2017 10:38'!
installUsers
		#(Tony Tom Lisa  Bob Robert) do: [:u| GbtBizAppServer default addUser: u withRole: GbtRole forExecute ]! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 6/6/2017 20:17'!
littleCompany
	^ GbtPlainAC struct: 'LittleCompany' define:
			{{#aspect:on:. LittleCompany productsContext. nil}.
			{#aspect:on:. Rolodex rolodex. nil}.
			{#aspect:on:. Invoices invoicesContext. nil}.
			{#uiSpec:icon: . #GbtMainUI . #littleCompany}.
			{#legalText: . 'GloConn International © 2016'}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 6/6/2017 20:26'!
login
	^ GbtPlainAC struct: 'LittleCompanyLogin' define: {
			{#displayAs: . #'Little Company'}.
			{#uiSpec:icon: . #GbtLoginUI . #littleCompany}.
			{#aspect:on: . self littleCompany . nil }.
			{#legalText: . 'GloConn International © 2016'}
		}! !

!LittleCompany class methodsFor: 'things' stamp: 'hk 5/2/2017 16:47'!
product
	^ GbtSmartThing
		struct: 'Product'
		define:
			{{#summary . '#amount pc à #price € = #total € . #description'}.
			{#idNumberPolicy . #BizIdPolicy}.
			{#description . #val: . ''}.
			{#amount . #val: . ''}.
			{#price . #val: . ''}.
			{#total . #calc:tag: . '#amount * #price' . #tprice}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:22'!
productContext  
	^GbtPlainAC struct: 'ProductContext' define: {
		{#displayAs: . 'Product'  } .
		{#uiSpec:icon: . #GbtItemUI . #taskOrders}}! !

!LittleCompany class methodsFor: 'contexts' stamp: 'hk 6/7/2017 10:49'!
productsContext  
	^GbtPrimeListAC struct: 'ProductsContext' define: {
		{#displayAs: . 'Products'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #taskOrders} .
		{#templates: . self product} .
		{#loadPolicy: . #simpleload } .
		{#display: . #( price amount total description)} .
		{#noPolicyPrefix: . 'Prod'}.
		{#subcontext: . self productContext} }! !

Object subclass: #Rolodex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_LittleCompany'!

!Rolodex class methodsFor: 'things' stamp: 'hk 5/26/2017 15:14'!
address
	^GbtSmartThing struct: 'Address' define: { 
	{ #summary . '#cityName'}.
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/26/2017 15:13'!
contact
	^GbtSmartThing struct: 'Contact' define: {
	{ #summary . '#cityName'}.
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #company . #val: . ''}.					
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:24'!
contactContext  
	self labelDeclarative .
	^GbtPlainAC struct: 'ContactContext' define: {
		{#displayAs: . 'Contacts'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
		{#menu: . #'print label' }.
		{#behavior:actions: . #'print label' . #(COMPOSE LabelDeclarative FREEZE thing TOPDF #(etikett pdfSlots) )}}! !

!Rolodex class methodsFor: 'example' stamp: 'hk 6/6/2017 19:48'!
exampleRun
	GbtBizAppServer clearStore; clear. 
	(self rolodex) ui title: #Rolodex; open! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
labelDeclarative
	^GbtDeclarative struct: 'LabelDeclarative' define: { 
		{ #pdfSlots . #decl: . self pdfSlots }.
		{ #firstName }.		
		{ #lastName }.
		{ #address }} ! !

!Rolodex class methodsFor: 'things' stamp: 'hk 5/2/2017 16:47'!
labelSticker
	^GbtSmartThing struct: 'Label' define: { "use calc to concatenate text"
		{ #nameLine . #calc: . ' '' #firstName '', '' '', '' #lastName '''}.		
		{ #streetLine . #calc: . ' '' #streetNo '', '' '', '' #street '' '}.
		{ #cityLine . #calc: . ' '' #cityCode '','' '', '' #cityName ''' }} ! !

!Rolodex class methodsFor: 'declaratives' stamp: 'hk 3/14/2017 13:01'!
pdfSlots
	^GbtDeclarative struct: 'pdfSlots' define: { 
		{ #nameLine }.		
		{ #streetLine }.
		{ #cityLine }} ! !

!Rolodex class methodsFor: 'contexts' stamp: 'hk 6/7/2017 10:49'!
rolodex  
	^GbtPrimeListAC struct: 'Rolodex' define: {
		{#displayAs: . 'Rolodex'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self contact} .
		{#loadPolicy: . #autoload } .
		{#display: . #(firstName lastName company cityName)} .
		{#subcontext: . self contactContext}.
		{#poolThings: . {self labelSticker} }}! !
